"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGrafservHooks = void 0;
const graphile_config_1 = require("graphile-config");
// We could use a global WeakMap, but storing directly onto the resolvedPreset
// should use more traditional garbage collection.
const $$hooks = Symbol("hooks");
function getGrafservHooks(resolvedPreset) {
    if (resolvedPreset[$$hooks]) {
        return resolvedPreset[$$hooks];
    }
    const hooks = new graphile_config_1.AsyncHooks();
    (0, graphile_config_1.applyHooks)(resolvedPreset.plugins, (p) => p.grafserv?.hooks, (name, fn, _plugin) => {
        const context = {
            resolvedPreset,
        };
        hooks.hook(name, ((...args) => fn(context, ...args)));
    });
    try {
        resolvedPreset[$$hooks] = hooks;
    }
    catch {
        // Ignore - preset must be readonly
    }
    return hooks;
}
exports.getGrafservHooks = getGrafservHooks;
//# sourceMappingURL=hooks.js.map